#==========================================================================
# gcc Makefile (autoconf ;-()
#==========================================================================
include files.mak
#==========================================================================
# åȤˤäƽ񤭴

## mach type: cygwin, mingw, linux, freebsd, darwin
MACH_TYPE = mingw

## target name
SHIORI = shiori

## if use STLport, set STLport=yes
STLport = yes

# (STLport) specify library include directory.
STLP_CFLAGS = -I/MinGW/include/stlport
STLP_LIBS = -lstlport_mingw32_static
## fi

## if you have 'upx'
UPX = upx

#==========================================================================
# EXPERIMENTAL FEATURES
#==========================================================================
# ʲϼ¸ŪץǤ

## if use Java SAORI, set JNI=yes
# JNI = yes

# (Java) specify Java Environments
# JAVA_HOME = c:/j2sdk1.4.1_01
# JNI_CFLAGS = -I$(JAVA_HOME)/include -I$(JAVA_HOME)/include/win32 -DENABLE_SAORI_JAVA -DENABLE_JAVA
# JNI_LIBS = -L./ -ljvm
## fi

## if use Python SAORI(and Python I/F), set PYTHON=yes
#PYTHON = yes

## (Python) and if win32
# PYTHON_CFLAGS = -I/python22jp/include
# PYTHON_LIBS = -L/python22jp/libs

#==========================================================================
# ʲŪ˽񤭴
#==========================================================================
include gcc-mach.mak

# LIBSRC
ifeq ($(STLport),yes)
	STLP_CFLAGS := $(STLP_CFLAGS) -DHAVE_SSTREAM
else
	STLP_CFLAGS :=
	STLP_LIBS   :=
endif


ifeq ($(JNI),yes)
	LIBSRC := $(LIBSRC) $(LIBSRC_java)
else
	JNI_CFLAGS :=
	JNI_LIBS   :=
endif

ifeq ($(PYTHON),yes)
	SHIOSRC := $(SHIOSRC) $(SHIOSRC_python)
	LIBSRC := $(LIBSRC) $(LIBSRC_python)
	ifndef PYTHON_CFLAGS
		PYTHON_CFLAGS = -I$(shell python -c "import sys; print sys.prefix+'/include/python'+sys.version[:3]")
	endif
	PYTHON_CFLAGS := $(PYTHON_CFLAGS) -DENABLE_SAORI_PYTHON
else
	PYTHON_CFLAGS :=
	PYTHON_LIBS   :=
endif

# SHIOSRC

# KOSUISRC
KOSUISRC_cygwin = $(KOSUISRC_win32)
KOSUISRC_mingw  = $(KOSUISRC_win32)
KOSUISRC := $(KOSUISRC) $(KOSUISRC_$(MACH_TYPE))

# flags
CFLAGS := -O2 -I. -DNDEBUG $(STLP_CFLAGS) $(CFLAGS_$(MACH_TYPE)) $(JNI_CFLAGS) $(PYTHON_CFLAGS) -Wall $(CFLAGS)
LDFLAGS := $(LIBS_$(MACH_TYPE)) $(STLP_LIBS) $(JNI_LIBS) $(PYTHON_LIBS) $(LDFLAGS)
DYNLIBDEF := shiori_$(MACH_TYPE).def

# commands
ifndef CXX
	CXX := $(CXX_$(MACH_TYPE))
endif
STRIP = strip
ifndef RUBY
	RUBY := ruby
endif
ifndef UPX
	UPX := $(shell \
		if [ -x upx ]; then echo "upx"; \
		else echo "echo"; fi)
endif

# filenames
MACH = ../mach/$(MACH_TYPE)
EXEEXT = $(EXEEXT_$(MACH_TYPE))
DYNLIBPREFIX = $(DYNLIBPREFIX_$(MACH_TYPE))
DYNLIBEXT = $(DYNLIBEXT_$(MACH_TYPE))
OBJEXT = .o
DYNIMPLIB = ../mach/$(MACH_TYPE)/$(SHIORI)$(LIBEXT_$(MACH_TYPE))

LIBOBJ =   $(LIBSRC:.cpp=$(OBJEXT))
SHIOOBJ =  $(SHIOSRC:.cpp=$(OBJEXT))
CRYPTOBJ = $(CRYPTSRC:.cpp=$(OBJEXT))
KOSUIOBJ = $(KOSUISRC:.cpp=$(OBJEXT))
TOOLOBJ =  $(TOOLSRC:.cpp=$(OBJEXT))

ALLTARGET = $(MACH)/$(DYNLIBPREFIX)$(SHIORI)$(DYNLIBEXT) \
            $(MACH)/kosui$(EXEEXT) \
            $(MACH)/kawari_encode$(EXEEXT) \
            $(MACH)/kawari_encode2$(EXEEXT) \
            $(MACH)/kawari_decode2$(EXEEXT)

## TARGETS ##

all : $(ALLTARGET) upx

../mach/cygwin/$(DYNLIBPREFIX)$(SHIORI)$(DYNLIBEXT) : $(SHIOOBJ) $(LIBOBJ)
	dlltool --output-def=$(DYNLIBDEF) -A -k $(SHIOOBJ) $(LIBOBJ)
	dllwrap --driver-name $(CXX) --def $(DYNLIBDEF) -o $@ $(SHIOOBJ) $(LIBOBJ) $(LDFLAGS)
	$(STRIP) $@

../mach/mingw/$(DYNLIBPREFIX)$(SHIORI)$(DYNLIBEXT) : $(SHIOOBJ) $(LIBOBJ)
	dlltool --output-def=$(DYNLIBDEF) --output-lib=$(DYNIMPLIB) -A -k $(SHIOOBJ) $(LIBOBJ)
	dllwrap --driver-name $(CXX) --def $(DYNLIBDEF) -o $@ $(SHIOOBJ) $(LIBOBJ) $(LDFLAGS)
	$(STRIP) $@

../mach/linux/$(DYNLIBPREFIX)$(SHIORI)$(DYNLIBEXT) : $(SHIOOBJ) $(LIBOBJ)
	$(CXX) -o $@ $(SHIOOBJ) $(LIBOBJ) $(LDFLAGS) -ldl -shared

../mach/freebsd/$(DYNLIBPREFIX)$(SHIORI)$(DYNLIBEXT) : $(SHIOOBJ) $(LIBOBJ)
	$(CXX) -o $@ $(SHIOOBJ) $(LIBOBJ) $(LDFLAGS) -shared

../mach/darwin/$(DYNLIBPREFIX)$(SHIORI)$(DYNLIBEXT): $(SHIOOBJ) $(LIBOBJ)
	$(CXX) -o $@ -bundle $(SHIOOBJ) $(LIBOBJ) $(LDFLAGS)

$(MACH)/kosui$(EXEEXT) : $(KOSUIOBJ) $(LIBOBJ)
	$(CXX) -o $@ $(KOSUIOBJ) $(LIBOBJ) $(LDFLAGS)
	$(STRIP) $@

$(MACH)/kawari_encode$(EXEEXT) : tool/kawari_encode$(OBJEXT) $(CRYPTOBJ)
	$(CXX) -o $@ tool/kawari_encode$(OBJEXT) $(CRYPTOBJ) $(LDFLAGS)
	$(STRIP) $@

$(MACH)/kawari_encode2$(EXEEXT) : tool/kawari_encode2$(OBJEXT) $(CRYPTOBJ)
	$(CXX) -o $@ tool/kawari_encode2$(OBJEXT) $(CRYPTOBJ) $(LDFLAGS)
	$(STRIP) $@

$(MACH)/kawari_decode2$(EXEEXT) : tool/kawari_decode2$(OBJEXT) $(CRYPTOBJ)
	$(CXX) -o $@ tool/kawari_decode2$(OBJEXT) $(CRYPTOBJ) $(LDFLAGS)
	$(STRIP) $@

.SUFFIXES : .cpp .h

%.o : %.cpp
	$(CXX) $(CFLAGS) -o$@ -c $<

clean :
	-rm $(LIBOBJ) $(SHIOOBJ) $(KOSUIOBJ) $(TOOLOBJ) $(TEMPORARY_FILES)

cleanall : clean
	-rm $(ALLTARGET)

depend : clean
	$(RUBY) ./makedepend.rb > depend.mak

upx : $(ALLTARGET)
	$(UPX) $(ALLTARGET)

include depend.mak
